﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace Persistence {
  public class Util {
    public static string AutoFormat(object o) {
      return AutoFormat(o, false);
    }
    public static string AutoFormat(object o, bool recursive) {
      Dictionary<object, int> visitedObjects = new Dictionary<object,int>();
      return AutoFormat(o, recursive, visitedObjects);
    }
    private static string AutoFormat(object o, bool recursive, Dictionary<object, int> visitedObjects) {
      string s = o as string;
      if (s != null)
        return s;
      if (o == null) {
        return "<null>";
      }
      if (visitedObjects.ContainsKey(o)) {
        return o.ToString();
      } else {
        visitedObjects.Add(o, 0);
      }      
      if (o.ToString() != o.GetType().ToString()) {
        return o.ToString();
      }
      StringBuilder sb = new StringBuilder();
      sb.Append(o.GetType().Name);
      sb.Append("(");
      foreach (MemberInfo mInfo in o.GetType().GetMembers(
        BindingFlags.Public |
        BindingFlags.NonPublic |
        BindingFlags.Instance)) {
        if (mInfo.MemberType == MemberTypes.Field) {
          FieldInfo fInfo = (FieldInfo)mInfo;          
          sb.Append(mInfo.Name);
          sb.Append("=");          
          if (recursive) {
            sb.Append(AutoFormat(((FieldInfo)mInfo).GetValue(o), true, visitedObjects));
          } else {
            sb.Append(((FieldInfo)mInfo).GetValue(o));
          }
          sb.Append(", ");
        }
      }
      sb.Remove(sb.Length - 2, 2);
      sb.Append(")");
      return sb.ToString();
    }
  }
}
